unit MainUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, FileCtrl;

type
config = record
 tosave:shortstring;
 end;

   TfmMain = class(TForm)
    btStart: TButton;
    Label1: TLabel;
    cbDisk: TComboBox;
    ProgressBar1: TProgressBar;
    StatusBar1: TStatusBar;
    btProperties: TButton;
    lbHistory: TListBox;
    bnClearHistory: TButton;
    procedure btStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btPropertiesClick(Sender: TObject);
    procedure bnClearHistoryClick(Sender: TObject);
  private
    { Private declarations }
  public
   { Public declarations }
   end;

var
  fmMain: TfmMain;
  workdir,dirtosave:string;
  filecfg:file of config;

implementation
uses propertiesUnit2, DirToSaveUnit3;
{$R *.DFM}
{$I-}


//Windir detection++++++++++++++++++++++++++++++++++++++++++++++++++++
Function DetectWinDir:string;

var
   drive:string;
      ph:string;
  windir:array [1..7] of string;
       i:integer;

 begin

 windir[1]:='windows';
 windir[2]:='win';
 windir[3]:='win98';
 windir[4]:='win95';
 windir[5]:='winme';
 windir[6]:='win9x';
 windir[7]:='notfound';


drive:=fmMain.cbDisk.Text;
i:=1;

// opredelenie dir windows
ph:=drive+':\'+windir[i]+'\';

while not DirectoryExists(ph) do
begin
 Inc(i);
 ph:=drive+':\'+windir[i]+'\';
  if i=7 then break;
end;

if windir[i]='notfound' then
  begin
     fmMain.StatusBar1.SimpleText:='  !';
     fmMain.lbHistory.Items.Add('  !');
     Result:='notfound';
     Exit;
 end;


fmMain.StatusBar1.SimpleText:='  :  '+ph;
fmMain.lbHistory.Items.Add('  :  '+ph);
// ph the dir of windows

 Result:=ph;

end;




// start++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
procedure TfmMain.btStartClick(Sender: TObject);

var
         ph,s,s1,s2:string;
               f,fn:PChar;
            pwlname:array [1..10] of string;
pwlcount,progress,i,l,x:integer;
                 sr:TsearchRec;




begin
// find pwl
ph:=DetectWinDir;
// ph the dir of windows
if ph='notfound' then exit;

begin
pwlcount:=1;
s:=ph+'*.pwl';
FindFirst(s,0,sr);
pwlname[pwlcount]:=sr.Name;
fmMain.lbHistory.Items.Add('   :  '+sr.Name);

while FindNext(sr)=0 do
begin
      Inc(pwlcount);
      pwlname[pwlcount]:=sr.Name;
      fmMain.lbHistory.Items.Add('   :  '+sr.Name);

end;
FindClose(sr);

s1:='';
s:=pwlname[1];
l:=Length(s);

for i:=1 to l-4 do s1:=s1+s[i];
s2:=DirToSave+'\'+s1+'\';
// s2=new dir

// proverka na sovpadenie dirov
i:=0;
if DirectoryExists(s2) then s1:=s1+'_0';

while  DirectoryExists(s2) do
 begin
  Inc(i);
  if i>10 then x:=2 else x:=1;//otsechenie nomera
  s2:='';
   for l:=1 to Length(s1)-x do s2:=s2+s1[l];
    s1:=s2+IntToStr(i);
    s2:=DirToSave+'\'+s1+'\';
end;

 fmMain.lbHistory.Items.Add('    :  '+s2);
 CreateDir(s2);
// s2=new dir


// copy pwl i ini
progress:=ProgressBar1.Max div (pwlcount+1);
ProgressBar1.Position:=0;

for i:=1 to pwlcount do
begin
        s:=ph+pwlname[i];
        StatusBar1.SimpleText:=' '+s;
        f:=PChar(s);
        s1:=s2+pwlname[i];
        fn:=PChar(s1);
        fmMain.lbHistory.Items.Add('   '+s+'   --->   '+s1);

        CopyFile(f,fn,false);
        ProgressBar1.StepBy(progress);
end;

s:=ph+'system.ini';
StatusBar1.SimpleText:=' '+s;
f:=PChar(s);
s1:=s2+'system.ini';
fn:=PChar(s1);
fmMain.lbHistory.Items.Add('   '+s+'   --->   '+s1);

CopyFile(f,fn,false);
ProgressBar1.StepBy(progress);
ProgressBar1.Position:=100;
StatusBar1.SimpleText:='...';

fmMain.lbHistory.Items.Add('...');

end;

end;



// load cfg file if exists++++++++++++++++++++++++++++++++++++++++++++
procedure TfmMain.FormCreate(Sender: TObject);
var
     cfg:file of config;
datafile:config;

begin

If not FileExists('getpwl.cfg') then
begin
 btStart.Enabled:=False;
 exit;
end;

  AssignFile(cfg,'getpwl.cfg');
  Reset(cfg);

  if FileSize(cfg)<>0 then
begin
  Read(cfg,datafile);
  DirToSave:=datafile.tosave;
  btStart.Enabled:=True;
end
  else

 begin
  btStart.Enabled:=False;
 end;
end;




//call form properties++++++++++++++++++++++++++++++++++++++++++++++++
procedure TfmMain.btPropertiesClick(Sender: TObject);

var
      cfg:file of config;
 datafile:config;

begin

Case fmProperties.ShowModal of

mrOK:

begin
DirToSave:=fmProperties.Edit1.Text;

if DirToSave='' then
begin
 Application.MessageBox('  ','   ',0);
 Exit;
end;

datafile.tosave:=DirToSave;

//workdir rabochaya directoriya programmu
workdir:=FmObzor.tempdir;

//inputbox('','',workdir);

AssignFile(cfg,workdir+'\'+'getpwl.cfg');
Rewrite(cfg);
write(cfg,datafile);
btStart.Enabled:=True;
end;

mrCANCEL:
 exit;

end;

end;


// Clear history++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
procedure TfmMain.bnClearHistoryClick(Sender: TObject);
begin
lbHistory.Items.Clear;
StatusBar1.SimpleText:=' ';
ProgressBar1.Position:=0;
end;

end.
